package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import java.util.Enumeration;

public class EncryptedPrivateKeyInfo extends ASN1Encodable {
   private AlgorithmIdentifier algId;
   private ASN1OctetString data;

   public EncryptedPrivateKeyInfo(ASN1Sequence seq) {
      EncryptedPrivateKeyInfo var10000 = this;
      super();
      Enumeration var2;
      this.algId = AlgorithmIdentifier.getInstance((var2 = seq.getObjects()).nextElement());
      var10000.data = (ASN1OctetString)var2.nextElement();
   }

   public EncryptedPrivateKeyInfo(AlgorithmIdentifier algId, byte[] encoding) {
      EncryptedPrivateKeyInfo var10000 = this;
      super();
      this.algId = algId;
      DEROctetString var3;
      var3 = new DEROctetString.<init>(encoding);
      var10000.data = var3;
   }

   public static EncryptedPrivateKeyInfo getInstance(Object obj) {
      if (obj instanceof EncryptedData) {
         return (EncryptedPrivateKeyInfo)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new EncryptedPrivateKeyInfo((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
      }
   }

   public AlgorithmIdentifier getEncryptionAlgorithm() {
      return this.algId;
   }

   public byte[] getEncryptedData() {
      return this.data.getOctets();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.algId);
      var10000.add(this.data);
      return new DERSequence(var1);
   }
}
